commit 7edb992d8195572e2c823fedab319eb6cb2f0f32
Author: Ian Lance Taylor <iant@golang.org>
Date:   Fri Sep 10 20:14:25 2021

    compiler: correct condition for calling memclrHasPointers
    
    When compiling append(s, make([]typ, ln)...), where typ has a pointer,
    and the append fits within the existing capacity of s, the condition
    used to clear out the new elements was reversed.
    
    Fixes golang/go#47771
    
    Reviewed-on: https://go-review.googlesource.com/c/gofrontend/+/344189

diff --git a/gcc/go/gofrontend/expressions.cc b/gcc/go/gofrontend/expressions.cc
index 6375922dac1..de8399f8231 100644
--- a/gcc/go/gofrontend/expressions.cc
+++ b/gcc/go/gofrontend/expressions.cc
@@ -9169,7 +9169,7 @@ Builtin_call_expression::flatten_append(Gogo* gogo, Named_object* function,
               ref2 = Expression::make_cast(uint_type, ref2, loc);
               cond = Expression::make_binary(OPERATOR_GT, ref, ref2, loc);
               zero = Expression::make_integer_ul(0, int_type, loc);
-              call = Expression::make_conditional(cond, call, zero, loc);
+              call = Expression::make_conditional(cond, zero, call, loc);
             }
         }
       else

